/*
 * This file is part of the SOAFaces Project (hereinafter "SOAFaces").
 * Copyright (C) 2006 Grand Logic, Inc.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */


package org.soafaces.bundle.client.rpc.impl;

import com.google.gwt.user.client.rpc.IsSerializable;
import com.google.gwt.user.client.rpc.RemoteService;
import java.util.Map;
import org.soafaces.bundle.client.rpc.AppCookie;
import org.soafaces.bundle.client.rpc.BeanTransferException;
import org.soafaces.bundle.client.rpc.TaskletStatus;

/**
 *
 * @author Sam Taha
 */
public interface BundleDataAccessRPC extends RemoteService {

  TaskletStatus getTaskletStatus(long jobid, long runid, long taskid) throws BeanTransferException;
  AppCookie getAppCookie(long jobid, long taskid) throws BeanTransferException;
  AppCookie setAppCookie(long jobid, long taskid, Map<String,String> editMap) throws BeanTransferException;

  IsSerializable getInputBeanPOJO(long jobid, long taskid, String stTaskPackageName, long effDate) throws BeanTransferException;
  String getInputBeanJSON(long jobid, long taskid, String stTaskPackageName, long effDate) throws BeanTransferException;
  
  IsSerializable getInputBeanRuntimePOJO(long jobid, long runid, long taskid, String stTaskPackageName) throws BeanTransferException;
  String getInputBeanRuntimeJSON(long jobid, long runid, long taskid, String stTaskPackageName) throws BeanTransferException;
  
  IsSerializable getOutputBeanRuntimePOJO(long jobid, long runid, long taskid, String stTaskPackageName) throws BeanTransferException;
  String getOutputBeanRuntimeJSON(long jobid, long runid, long taskid, String stTaskPackageName) throws BeanTransferException;
  
  void setInputBeanPOJO(long jobid, long taskid, boolean bIsApp, IsSerializable bean, String stTaskPackageName, long effDate) throws BeanTransferException;
  void setInputBeanJSON(long jobid, long taskid, boolean bIsApp, String jsonBean, String stTaskPackageName, long effDate) throws BeanTransferException;
  
  void cacheTmpInputBeanPOJO(long jobid, long taskid, IsSerializable bean) throws BeanTransferException;
  void cacheTmpInputBeanJSON(long jobid, long taskid, String jsonBean) throws BeanTransferException;
}
